
import sys
import os
import argparse


parser = argparse.ArgumentParser(description="convert a binary file into an ascii array")
parser.add_argument('-mode', type=str, choices=['ascii','c'], default='ascii', help="uint8_t C array, or ascii list of bytes")
parser.add_argument('-infile', type=str, required=True )
parser.add_argument('-o', type=str, required=True )
args = parser.parse_args()

varname = os.path.splitext(os.path.basename(args.infile))[0]

f = open(args.infile,"rb")
o = open(args.o,"w")

comma = ""
tab = ""

if args.mode is 'c':
  o.write("uint8_t %s[] = {\n" % varname)
  tab = '\t'

try:
  bytesread = f.read(8192)
  while bytesread:
    for b in bytesread:
      o.write("%s%s0x%x" % (comma,tab,ord(b)) )
      comma = ",\n"
    bytesread = f.read(256)

finally:
  f.close()

if args.mode is 'c':
  o.write(" };\n");

o.close()



